"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// Import Libs and Handlers
var React = tslib_1.__importStar(require("react"));
var mobx_1 = require("mobx");
var lodash_es_1 = require("lodash-es");
var global_api_1 = require("../app/global-api"); // 取对应子包app
var RenderWrapper_1 = require("../handlers/RenderWrapper");
var weda_client_1 = require("@cloudbase/weda-client");
var utils_1 = require("../utils");
var index_1 = require("../utils/index");
var lifecycle_1 = require("../utils/lifecycle");
var hooks_1 = require("../utils/hooks");
var cals_1 = require("@cloudbase/cals");
var adapter_1 = require("../utils/adapter");
var qiankun_1 = require("qiankun");
var router_1 = require("../router");
var createDataset = weda_client_1._WEDA_CLOUD_SDK.createDataset, createStateDataSourceVar = weda_client_1._WEDA_CLOUD_SDK.createStateDataSourceVar, generateParamsParser = weda_client_1._WEDA_CLOUD_SDK.generateParamsParser, EXTRA_API = weda_client_1._WEDA_CLOUD_SDK.EXTRA_API;
function useMemoOrDeep(value, memo) {
    var ref = React.useRef(value);
    return React.useMemo(function () {
        if (memo || !(0, lodash_es_1.isEqual)(ref.current, value)) {
            ref.current = value;
        }
        return ref.current;
    }, [value]);
}
function useObserverControledDataContext(inited, injectContext, initDataContext) {
    var dataContextRef = React.useRef((0, mobx_1.observable)((injectContext === null || injectContext === void 0 ? void 0 : injectContext.dataContext) || initDataContext));
    return React.useMemo(function () {
        if (inited && (injectContext === null || injectContext === void 0 ? void 0 : injectContext.dataContext)) {
            if (dataContextRef.current) {
                // eslint-disable-next-line no-restricted-syntax
                for (var key in dataContextRef.current) {
                    if (!injectContext.dataContext[key]) {
                        dataContextRef.current[key] = null;
                    }
                }
            }
            // eslint-disable-next-line no-restricted-syntax
            for (var key in injectContext.dataContext) {
                dataContextRef.current[key] = injectContext.dataContext[key];
            }
            // setFourceUpdate(Date.now());
        }
        return dataContextRef.current;
    }, [inited, injectContext === null || injectContext === void 0 ? void 0 : injectContext.dataContext]);
}
// Init
// eslint-disable-next-line react/display-name
function App(_a) {
    var _page = _a.page, generateComponentsMap = _a.generateComponentsMap, generateActionsMap = _a.generateActionsMap, generateLowcodeModule = _a.generateLowcodeModule, generateWidgetsContext = _a.generateWidgetsContext, generateDataBinds = _a.generateDataBinds, generateComponentSchema = _a.generateComponentSchema, generateContext = _a.generateContext, onRender = _a.onRender, onMounted = _a.onMounted, _b = _a.initDataContext, initDataContext = _b === void 0 ? {} : _b, options = _a.options;
    var page = useMemoOrDeep(_page, !options.reuseWidget);
    var injectContext = React.useContext(router_1.InjectContext);
    var _c = tslib_1.__read(React.useState(false), 2), pageContextInited = _c[0], setPageContextInited = _c[1];
    var _d = tslib_1.__read(React.useState(Date.now()), 2), _ = _d[0], setFourceUpdate = _d[1];
    // 数据容器的上下文数据
    var widgetsContextRef = React.useRef({});
    var _e = (options || {}).reuseWidget, reuseWidget = _e === void 0 ? false : _e;
    // 兼容 this.state / $page.state 两种模式
    var pageCodeContextRef = React.useRef((injectContext === null || injectContext === void 0 ? void 0 : injectContext.$page) || (0, global_api_1.createPageApi)());
    var $page = pageCodeContextRef.current;
    var lowcode = generateLowcodeModule();
    React.useEffect(function () {
        if (!(injectContext === null || injectContext === void 0 ? void 0 : injectContext.$page)) {
            var dataset = createDataset(page.id);
            var state = (0, mobx_1.observable)(lowcode.state || {});
            state.dataset = dataset;
            Object.assign($page, {
                id: page.id,
                state: state,
                computed: (0, index_1.createComputed)(lowcode.computed || {}, pageCodeContextRef.current),
                handler: (0, index_1.bindFuncObj)(lowcode.handler || {}, pageCodeContextRef.current),
                randerer: lowcode.renderer,
                dataset: dataset,
            });
        }
        Object.assign($page, {
            __internal__: tslib_1.__assign(tslib_1.__assign({}, $page.__internal__), { $w: new Proxy(global_api_1.$w, {
                    get: function (obj, prop) {
                        // 尝试代理页面级别组件实例
                        var pageWidget = (0, lodash_es_1.get)($page, "widgets.".concat(prop));
                        if (pageWidget) {
                            return pageWidget._userWidget;
                        }
                        return obj[prop];
                    },
                }) }),
        });
        setPageContextInited(true);
    }, []);
    var dataContext = useObserverControledDataContext(pageContextInited, injectContext, initDataContext);
    var _f = React.useMemo(function () {
        if (pageContextInited) {
            var globalCtx = {
                $page: $page,
                app: global_api_1.app,
                $app: global_api_1.app,
                actionsMap: (generateActionsMap === null || generateActionsMap === void 0 ? void 0 : generateActionsMap()) || {},
            };
            var widgetsContext_1;
            var databinds = void 0;
            var componentSchema_1;
            if (generateContext) {
                var context = generateContext(globalCtx, page);
                widgetsContext_1 = context.widgetContext;
                databinds = context.dataBinds;
                componentSchema_1 = context.componentSchema;
            }
            else {
                widgetsContext_1 = generateWidgetsContext(page);
                databinds = generateDataBinds(globalCtx, page);
                componentSchema_1 = generateComponentSchema(globalCtx, page);
            }
            // widgets 内的 dataBinds 可能需要关联 widgets，需要重新执行 dataBinds
            $page._dataBinds = databinds;
            return { componentSchema: componentSchema_1, widgetsContext: widgetsContext_1 };
        }
        return {};
    }, [pageContextInited, page]), componentSchema = _f.componentSchema, widgetsContext = _f.widgetsContext;
    widgetsContextRef.current = React.useMemo(function () {
        if (pageContextInited) {
            var _a = (0, index_1.createWidgets)(tslib_1.__assign({ apiContext: $page }, (reuseWidget ? widgetsContextRef.current : {})), widgetsContext, $page._dataBinds || {}, dataContext), widgets = _a.widgets, nodeMap = _a.nodeMap;
            $page.widgets = widgets;
            (0, index_1.retryDataBinds)();
            if (reuseWidget) {
                var widgets_1 = (widgetsContextRef.current || {}).widgets;
                if (widgets_1 === null || widgets_1 === void 0 ? void 0 : widgets_1._disposers) {
                    widgets_1._disposers.forEach(function (dispose) { return dispose(); });
                    widgets_1._disposers = [];
                }
            }
            return { widgetProps: widgetsContext, nodeMap: nodeMap, widgets: widgets };
        }
        else {
            return widgetsContextRef.current;
        }
    }, [widgetsContext, dataContext]);
    React.useEffect(function () {
        return function () {
            var _a, _b, _c, _d;
            if ((_b = (_a = pageCodeContextRef.current) === null || _a === void 0 ? void 0 : _a.widgets) === null || _b === void 0 ? void 0 : _b._disposers) {
                (_d = (_c = pageCodeContextRef.current) === null || _c === void 0 ? void 0 : _c.widgets) === null || _d === void 0 ? void 0 : _d._disposers.forEach(function (dispose) { return dispose(); });
                pageCodeContextRef.current.widgets._disposers = [];
            }
        };
    }, []);
    return (pageContextInited && (React.createElement(AppContent, { page: page, lowcode: lowcode, componentSchema: componentSchema, pageCodeContext: pageCodeContextRef.current, virtualFields: generateComponentsMap(), onMounted: onMounted, onRender: onRender, 
        // dataContext={dataContext}
        /**
         * 更新数据容器的上下文的方法
         * 会传递到事件emit的地方，将从组件获取到的数据data赋值给上下文
         * 当组件卸载时，传过来的data为undefined即可
         * {
         *   id1: [{...}],
         *   id2: {...},
         *   id3: undefined,
         *   id4: null,
         *   ...
         * }
         * @param id
         * @param data
         */
        // updateContext={function (id, data) {
        //   if (id && !injectContext?.dataContext) {
        //     dataContext[id] = { data };
        //   }
        //   injectContext?.onDataContextChange?.(id, data);
        // }}
        options: options })));
}
exports.default = App;
function AppContent(_a) {
    var _this = this;
    var _b, _c, _d, _e, _f;
    var page = _a.page, lowcode = _a.lowcode, componentSchema = _a.componentSchema, pageCodeContext = _a.pageCodeContext, virtualFields = _a.virtualFields, _g = _a.onMounted, onMounted = _g === void 0 ? function (props) {
        var _a;
        // eslint-disable-next-line react/prop-types
        (_a = props === null || props === void 0 ? void 0 : props.default) === null || _a === void 0 ? void 0 : _a.call(props);
    } : _g, _h = _a.onRender, onRender = _h === void 0 ? function () { } : _h, 
    // dataContext,
    // updateContext,
    options = _a.options;
    var _j = options.processCssUnit, processCssUnit = _j === void 0 ? 'rem' : _j;
    // 检查权限
    var _k = tslib_1.__read(React.useState(false), 2), weDaHasLogin = _k[0], setWeDaHasLogin = _k[1];
    var containerRef = React.useRef(null);
    var externalClassRef = React.useRef('');
    var microApp = React.useRef(null);
    var pureSrc = (_b = page.attributes) === null || _b === void 0 ? void 0 : _b.src;
    var isPure = !!pureSrc;
    var _l = React.useContext(router_1.InjectContext), _m = _l.checkPageAuth, checkPageAuth = _m === void 0 ? index_1.checkAuth : _m, _o = _l.generateLoginUrl, generateLoginUrl = _o === void 0 ? index_1.defaultGenerateLoginUrl : _o;
    // Web 环境页面级别生命周期
    (0, lifecycle_1.usePageLifeCycle)(tslib_1.__assign(tslib_1.__assign({}, lowcode === null || lowcode === void 0 ? void 0 : lowcode.lifecycle), { events: getPageEvents(componentSchema), 
        // eslint-disable-next-line @typescript-eslint/no-misused-promises
        beforePageCustomLaunch: function (query) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var checkAuthResult;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onMounted({
                            page: page,
                            default: function () {
                                var _a;
                                var document = (adapter_1.runtime === null || adapter_1.runtime === void 0 ? void 0 : adapter_1.runtime.document) || window.document;
                                document.title = ((_a = page.attributes) === null || _a === void 0 ? void 0 : _a.title) || page.id;
                            },
                        });
                        EXTRA_API.setParams(page.id, query || {});
                        initWatchMethods(pageCodeContext);
                        return [4 /*yield*/, checkPageAuth(global_api_1.app, global_api_1.app.id, pageCodeContext, generateLoginUrl)];
                    case 1:
                        checkAuthResult = _a.sent();
                        setWeDaHasLogin(checkAuthResult);
                        createStateDataSourceVar(page.id, generateParamsParser({ app: global_api_1.app, $page: pageCodeContext }));
                        onRender === null || onRender === void 0 ? void 0 : onRender();
                        return [2 /*return*/];
                }
            });
        }); } }), { app: global_api_1.app, page: pageCodeContext, options: { looseError: options === null || options === void 0 ? void 0 : options.looseError } });
    // 切换页面滚动到顶部
    (0, hooks_1.useScrollTop)();
    React.useEffect(function () {
        var _a, _b;
        if (isPure) {
            if (weDaHasLogin) {
                if (!microApp.current) {
                    microApp.current = (0, qiankun_1.loadMicroApp)({
                        name: page.id,
                        entry: pureSrc,
                        container: containerRef.current,
                    }, {
                        fetch: adapter_1.runtime.fetch,
                    });
                }
                else {
                    (_b = (_a = microApp.current).mount) === null || _b === void 0 ? void 0 : _b.call(_a);
                }
            }
            else if (microApp.current) {
                microApp.current.unmount();
            }
        }
    }, [weDaHasLogin]);
    React.useEffect(function () {
        global_api_1.app.__internal__.activePage = pageCodeContext;
        return function () {
            if (microApp.current) {
                microApp.current.unmount();
            }
        };
    }, []);
    React.useEffect(function () {
        function resize() {
            var _a, _b;
            var className = "wd-".concat(((_b = (_a = global_api_1.app === null || global_api_1.app === void 0 ? void 0 : global_api_1.app.__internal__) === null || _a === void 0 ? void 0 : _a.isMobile) === null || _b === void 0 ? void 0 : _b.call(_a)) ? 'h5' : 'pc', "-root");
            if (externalClassRef.current === className) {
                return;
            }
            if (containerRef.current.classList.contains(externalClassRef.current)) {
                containerRef.current.classList.replace(externalClassRef.current, className);
            }
            else {
                containerRef.current.classList.add(className);
            }
            externalClassRef.current = className;
        }
        resize();
        adapter_1.runtime === null || adapter_1.runtime === void 0 ? void 0 : adapter_1.runtime.addEventListener('resize', resize);
        return function () {
            adapter_1.runtime === null || adapter_1.runtime === void 0 ? void 0 : adapter_1.runtime.removeEventListener('resize', resize);
        };
    }, []);
    return (React.createElement("div", { ref: containerRef, className: "weapps-page weapps-page-".concat(page.id, " ").concat(externalClassRef.current) },
        React.createElement("style", { type: "text/css", dangerouslySetInnerHTML: {
                __html: "".concat((0, index_1.toCssText)(((_c = page.attributes) === null || _c === void 0 ? void 0 : _c.style) ||
                    (0, cals_1.processCommonStyle2CSSProperties)(((_d = page === null || page === void 0 ? void 0 : page.extra) === null || _d === void 0 ? void 0 : _d.commonStyle) || {}, {
                        defaultUnit: processCssUnit,
                        rpxCalcRoot: "var(".concat(utils_1.CALC_RPX_ROOT_VAL_NAME, ")"),
                    }), 'body')).concat((lowcode.style || []).map(function (item) { return item.code; }).join('\n')),
            } }),
        weDaHasLogin &&
            !isPure &&
            (((_e = lowcode.lifecycle) === null || _e === void 0 ? void 0 : _e.onPageRender) ? ((_f = lowcode.lifecycle) === null || _f === void 0 ? void 0 : _f.onPageRender()) : (React.createElement(RenderWrapper_1.AppRender, { virtualFields: virtualFields, componentSchema: componentSchema, codeContext: pageCodeContext })))));
}
function initWatchMethods(pageContext) {
    // const { watch = {}, watchState = {}, watchWidget = {}, watchEffects = {}} = pageAPI
    var _a = {}, _b = _a.watch, watch = _b === void 0 ? {} : _b, _c = _a.watchState, watchState = _c === void 0 ? {} : _c, _d = _a.watchWidget, watchWidget = _d === void 0 ? {} : _d, _e = _a.watchEffects, watchEffects = _e === void 0 ? {} : _e;
    // # watch effect
    var watchEffectDisposers = Object.keys(watchEffects).map(function (fnName) {
        return (0, mobx_1.autorun)(watchEffects[fnName].bind(pageContext));
    });
    var disposers = watchEffectDisposers;
    // # watch state
    Object.keys(watchState).map(function (key) { return runWatcher(parseWatcher(watchState[key]), pageContext.state, key, 'watchState'); });
    // # watch widgets
    Object.keys(watchWidget).map(function (key) {
        return runWatcher(parseWatcher(watchWidget[key]), pageContext.widgets, key, 'watchWidgets');
    });
    function runWatcher(_a, target, key, label) {
        var _b = _a === void 0 ? {} : _a, handler = _b.handler, immediate = _b.immediate;
        if (!handler) {
            console.error("Invalid ".concat(label, "(").concat(key, ") of ").concat(pageContext.node.widgetType, ", watch must a function or {handler: function}"));
            return;
        }
        var disposer = (0, mobx_1.reaction)(function () { return (0, lodash_es_1.get)(target, key); }, handler.bind(pageContext), { fireImmediately: immediate });
        disposers.push(disposer);
    }
}
function parseWatcher(watcher) {
    if (!watcher)
        return;
    if (watcher instanceof Function) {
        return { handler: watcher, immediate: false };
    }
    var handler = watcher.handler, _a = watcher.immediate, immediate = _a === void 0 ? false : _a;
    if (!(handler instanceof Function))
        return;
    return { handler: handler, immediate: immediate };
}
function getPageEvents(componentSchema) {
    var emit = (0, utils_1.generateEmit)();
    return new Proxy({}, {
        get: function (target, eventName) {
            return function (eventData) { return emit(eventName, componentSchema.listenerInstances, eventData, {}, {}, {}, {}); };
        },
    });
}
//# sourceMappingURL=index.js.map